1# Test framework for git. See t/README for usage.
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
17
18# Keep the original TERM for say_color
19ORIGINAL_TERM=$TERM
20
21# Test the binaries we have just built. The tests are kept in
22# t/ subdirectory and are run in 'trash directory' subdirectory.
23if test -z "$TEST_DIRECTORY"
24then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
29else
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
33fi
34if test -z "$TEST_OUTPUT_DIRECTORY"
35then
36 # Similarly, override this to store the test-results subdir
37 # elsewhere
38 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
39fi
40GIT_BUILD_DIR="$TEST_DIRECTORY"/..
41
42################################################################
43# It appears that people try to run tests without building...
44"$GIT_BUILD_DIR/git" >/dev/null
45if test $? != 1
46then
47 echo >&2 'error: you do not seem to have built git yet.'
48 exit 1
49fi
50
51. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52export PERL_PATH SHELL_PATH
53
54# if --tee was passed, write the output not only to the terminal, but
55# additionally to the file test-results/$BASENAME.out, too.
56case "$GIT_TEST_TEE_STARTED, $* " in
57done,*)
58 # do not redirect again
59 ;;
60*' --tee '*|*' --va'*)
61 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
63 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $? > $BASE.exit) | tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
66 exit
67 ;;
68esac
69
70# For repeatability, reset the environment to known value.
71LANG=C
72LC_ALL=C
73PAGER=cat
74TZ=UTC
75TERM=dumb
76export LANG LC_ALL PAGER TERM TZ
77EDITOR=:
78# A call to "unset" with no arguments causes at least Solaris 10
79# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80# deriving from the command substitution clustered with the other
81# ones.
82unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
83 my @env = keys %ENV;
84 my $ok = join("|", qw(
85 TRACE
86 DEBUG
87 USE_LOOKUP
88 TEST
89 .*_TEST
90 PROVE
91 VALGRIND
92 UNZIP
93 PERF_
94 CURL_VERBOSE
95 ));
96 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
97 print join("\n", @vars);
98')
99unset XDG_CONFIG_HOME
100unset GITPERLLIB
101GIT_AUTHOR_EMAIL=author@example.com
102GIT_AUTHOR_NAME='A U Thor'
103GIT_COMMITTER_EMAIL=committer@example.com
104GIT_COMMITTER_NAME='C O Mitter'
105GIT_MERGE_VERBOSITY=5
106GIT_MERGE_AUTOEDIT=no
107export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
108export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
109export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
110export EDITOR
111
112# Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
113GIT_TRACE_BARE=1
114export GIT_TRACE_BARE
115
116if test -n "${TEST_GIT_INDEX_VERSION:+isset}"
117then
118 GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION"
119 export GIT_INDEX_VERSION
120fi
121
122# Add libc MALLOC and MALLOC_PERTURB test
123# only if we are not executing the test with valgrind
124if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
125 test -n "$TEST_NO_MALLOC_CHECK"
126then
127 setup_malloc_check () {
128 : nothing
129 }
130 teardown_malloc_check () {
131 : nothing
132 }
133else
134 setup_malloc_check () {
135 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
136 export MALLOC_CHECK_ MALLOC_PERTURB_
137 }
138 teardown_malloc_check () {
139 unset MALLOC_CHECK_ MALLOC_PERTURB_
140 }
141fi
142
143: ${ASAN_OPTIONS=detect_leaks=0}
144export ASAN_OPTIONS
145
146# Protect ourselves from common misconfiguration to export
147# CDPATH into the environment
148unset CDPATH
149
150unset GREP_OPTIONS
151unset UNZIP
152
153case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1541|2|true)
155 echo "* warning: Some tests will not work if GIT_TRACE" \
156 "is set as to trace on STDERR ! *"
157 echo "* warning: Please set GIT_TRACE to something" \
158 "other than 1, 2 or true ! *"
159 ;;
160esac
161
162# Convenience
163#
164# A regexp to match 5 and 40 hexdigits
165_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
166_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
167
168# Zero SHA-1
169_z40=0000000000000000000000000000000000000000
170
171# Line feed
172LF='
173'
174
175# UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
176# when case-folding filenames
177u200c=$(printf '\342\200\214')
178
179export _x05 _x40 _z40 LF u200c
180
181# Each test should start with something like this, after copyright notices:
182#
183# test_description='Description of this test...
184# This test checks if command xyzzy does the right thing...
185# '
186# . ./test-lib.sh
187
188unset color
189while test "$#" -ne 0
190do
191 case "$1" in
192 -d|--d|--de|--deb|--debu|--debug)
193 debug=t; shift ;;
194 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
195 immediate=t; shift ;;
196 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
197 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
198 -r)
199 shift; test "$#" -ne 0 || {
200 echo 'error: -r requires an argument' >&2;
201 exit 1;
202 }
203 run_list=$1; shift ;;
204 --run=*)
205 run_list=$(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;;
206 -h|--h|--he|--hel|--help)
207 help=t; shift ;;
208 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
209 verbose=t; shift ;;
210 --verbose-only=*)
211 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
212 shift ;;
213 -q|--q|--qu|--qui|--quie|--quiet)
214 # Ignore --quiet under a TAP::Harness. Saying how many tests
215 # passed without the ok/not ok details is always an error.
216 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
217 --with-dashes)
218 with_dashes=t; shift ;;
219 --no-color)
220 color=; shift ;;
221 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
222 valgrind=memcheck
223 shift ;;
224 --valgrind=*)
225 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
226 shift ;;
227 --valgrind-only=*)
228 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
229 shift ;;
230 --tee)
231 shift ;; # was handled already
232 --root=*)
233 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
234 shift ;;
235 --chain-lint)
236 GIT_TEST_CHAIN_LINT=1
237 shift ;;
238 --no-chain-lint)
239 GIT_TEST_CHAIN_LINT=0
240 shift ;;
241 -x)
242 trace=t
243 verbose=t
244 shift ;;
245 *)
246 echo "error: unknown test option '$1'" >&2; exit 1 ;;
247 esac
248done
249
250if test -n "$valgrind_only"
251then
252 test -z "$valgrind" && valgrind=memcheck
253 test -z "$verbose" && verbose_only="$valgrind_only"
254elif test -n "$valgrind"
255then
256 verbose=t
257fi
258
259error () {
260 say_color error "error: $*"
261 GIT_EXIT_OK=t
262 exit 1
263}
264
265say () {
266 say_color info "$*"
267}
268
269test "${test_description}" != "" ||
270error "Test script did not set test_description."
271
272if test "$help" = "t"
273then
274 printf '%s\n' "$test_description"
275 exit 0
276fi
277
278exec 5>&1
279exec 6<&0
280if test "$verbose" = "t"
281then
282 exec 4>&2 3>&1
283else
284 exec 4>/dev/null 3>/dev/null
285fi
286
287test_failure=0
288test_count=0
289test_fixed=0
290test_broken=0
291test_success=0
292
293test_external_has_tap=0
294
295die () {
296 code=$?
297 if test -n "$GIT_EXIT_OK"
298 then
299 exit $code
300 else
301 echo >&5 "FATAL: Unexpected exit with code $code"
302 exit 1
303 fi
304}
305
306GIT_EXIT_OK=
307trap 'die' EXIT
308
309# The user-facing functions are loaded from a separate file so that
310# test_perf subshells can have them too
311. "$TEST_DIRECTORY/test-lib-functions.sh"
312
313# You are not expected to call test_ok_ and test_failure_ directly, use
314# the test_expect_* functions instead.
315
316test_ok_ () {
317 test_success=$(($test_success + 1))
318 say_color "" "ok $test_count - $@"
319}
320
321test_failure_ () {
322 test_failure=$(($test_failure + 1))
323 say_color error "not ok $test_count - $1"
324 shift
325 printf '%s\n' "$*" | sed -e 's/^/# /'
326 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
327}
328
329test_known_broken_ok_ () {
330 test_fixed=$(($test_fixed+1))
331 say_color error "ok $test_count - $@ # TODO known breakage vanished"
332}
333
334test_known_broken_failure_ () {
335 test_broken=$(($test_broken+1))
336 say_color warn "not ok $test_count - $@ # TODO known breakage"
337}
338
339test_debug () {
340 test "$debug" = "" || eval "$1"
341}
342
343match_pattern_list () {
344 arg="$1"
345 shift
346 test -z "$*" && return 1
347 for pattern_
348 do
349 case "$arg" in
350 $pattern_)
351 return 0
352 esac
353 done
354 return 1
355}
356
357match_test_selector_list () {
358 title="$1"
359 shift
360 arg="$1"
361 shift
362 test -z "$1" && return 0
363
364 # Both commas and whitespace are accepted as separators.
365 OLDIFS=$IFS
366 IFS=' ,'
367 set -- $1
368 IFS=$OLDIFS
369
370 # If the first selector is negative we include by default.
371 include=
372 case "$1" in
373 !*) include=t ;;
374 esac
375
376 for selector
377 do
378 orig_selector=$selector
379
380 positive=t
381 case "$selector" in
382 !*)
383 positive=
384 selector=${selector##?}
385 ;;
386 esac
387
388 test -z "$selector" && continue
389
390 case "$selector" in
391 *-*)
392 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
393 then
394 echo "error: $title: invalid non-numeric in range" \
395 "start: '$orig_selector'" >&2
396 exit 1
397 fi
398 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
399 then
400 echo "error: $title: invalid non-numeric in range" \
401 "end: '$orig_selector'" >&2
402 exit 1
403 fi
404 ;;
405 *)
406 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
407 then
408 echo "error: $title: invalid non-numeric in test" \
409 "selector: '$orig_selector'" >&2
410 exit 1
411 fi
412 esac
413
414 # Short cut for "obvious" cases
415 test -z "$include" && test -z "$positive" && continue
416 test -n "$include" && test -n "$positive" && continue
417
418 case "$selector" in
419 -*)
420 if test $arg -le ${selector#-}
421 then
422 include=$positive
423 fi
424 ;;
425 *-)
426 if test $arg -ge ${selector%-}
427 then
428 include=$positive
429 fi
430 ;;
431 *-*)
432 if test ${selector%%-*} -le $arg \
433 && test $arg -le ${selector#*-}
434 then
435 include=$positive
436 fi
437 ;;
438 *)
439 if test $arg -eq $selector
440 then
441 include=$positive
442 fi
443 ;;
444 esac
445 done
446
447 test -n "$include"
448}
449
450maybe_teardown_verbose () {
451 test -z "$verbose_only" && return
452 exec 4>/dev/null 3>/dev/null
453 verbose=
454}
455
456last_verbose=t
457maybe_setup_verbose () {
458 test -z "$verbose_only" && return
459 if match_pattern_list $test_count $verbose_only
460 then
461 exec 4>&2 3>&1
462 # Emit a delimiting blank line when going from
463 # non-verbose to verbose. Within verbose mode the
464 # delimiter is printed by test_expect_*. The choice
465 # of the initial $last_verbose is such that before
466 # test 1, we do not print it.
467 test -z "$last_verbose" && echo >&3 ""
468 verbose=t
469 else
470 exec 4>/dev/null 3>/dev/null
471 verbose=
472 fi
473 last_verbose=$verbose
474}
475
476maybe_teardown_valgrind () {
477 test -z "$GIT_VALGRIND" && return
478 GIT_VALGRIND_ENABLED=
479}
480
481maybe_setup_valgrind () {
482 test -z "$GIT_VALGRIND" && return
483 if test -z "$valgrind_only"
484 then
485 GIT_VALGRIND_ENABLED=t
486 return
487 fi
488 GIT_VALGRIND_ENABLED=
489 if match_pattern_list $test_count $valgrind_only
490 then
491 GIT_VALGRIND_ENABLED=t
492 fi
493}
494
495# This is a separate function because some tests use
496# "return" to end a test_expect_success block early
497# (and we want to make sure we run any cleanup like
498# "set +x").
499test_eval_inner_ () {
500 # Do not add anything extra (including LF) after '$*'
501 eval "
502 test \"$trace\" = t && set -x
503 $*"
504}
505
506test_eval_ () {
507 # We run this block with stderr redirected to avoid extra cruft
508 # during a "-x" trace. Once in "set -x" mode, we cannot prevent
509 # the shell from printing the "set +x" to turn it off (nor the saving
510 # of $? before that). But we can make sure that the output goes to
511 # /dev/null.
512 #
513 # The test itself is run with stderr put back to &4 (so either to
514 # /dev/null, or to the original stderr if --verbose was used).
515 {
516 test_eval_inner_ "$@" </dev/null >&3 2>&4
517 test_eval_ret_=$?
518 if test "$trace" = t
519 then
520 set +x
521 if test "$test_eval_ret_" != 0
522 then
523 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
524 fi
525 fi
526 } 2>/dev/null
527 return $test_eval_ret_
528}
529
530test_run_ () {
531 test_cleanup=:
532 expecting_failure=$2
533
534 if test "${GIT_TEST_CHAIN_LINT:-0}" != 0; then
535 # 117 is magic because it is unlikely to match the exit
536 # code of other programs
537 test_eval_ "(exit 117) && $1"
538 if test "$?" != 117; then
539 error "bug in the test script: broken &&-chain: $1"
540 fi
541 fi
542
543 setup_malloc_check
544 test_eval_ "$1"
545 eval_ret=$?
546 teardown_malloc_check
547
548 if test -z "$immediate" || test $eval_ret = 0 ||
549 test -n "$expecting_failure" && test "$test_cleanup" != ":"
550 then
551 setup_malloc_check
552 test_eval_ "$test_cleanup"
553 teardown_malloc_check
554 fi
555 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
556 then
557 echo ""
558 fi
559 return "$eval_ret"
560}
561
562test_start_ () {
563 test_count=$(($test_count+1))
564 maybe_setup_verbose
565 maybe_setup_valgrind
566}
567
568test_finish_ () {
569 echo >&3 ""
570 maybe_teardown_valgrind
571 maybe_teardown_verbose
572}
573
574test_skip () {
575 to_skip=
576 skipped_reason=
577 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
578 then
579 to_skip=t
580 skipped_reason="GIT_SKIP_TESTS"
581 fi
582 if test -z "$to_skip" && test -n "$test_prereq" &&
583 ! test_have_prereq "$test_prereq"
584 then
585 to_skip=t
586
587 of_prereq=
588 if test "$missing_prereq" != "$test_prereq"
589 then
590 of_prereq=" of $test_prereq"
591 fi
592 skipped_reason="missing $missing_prereq${of_prereq}"
593 fi
594 if test -z "$to_skip" && test -n "$run_list" &&
595 ! match_test_selector_list '--run' $test_count "$run_list"
596 then
597 to_skip=t
598 skipped_reason="--run"
599 fi
600
601 case "$to_skip" in
602 t)
603 say_color skip >&3 "skipping test: $@"
604 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
605 : true
606 ;;
607 *)
608 false
609 ;;
610 esac
611}
612
613# stub; perf-lib overrides it
614test_at_end_hook_ () {
615 :
616}
617
618test_done () {
619 GIT_EXIT_OK=t
620
621 if test -z "$HARNESS_ACTIVE"
622 then
623 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
624 mkdir -p "$test_results_dir"
625 base=${0##*/}
626 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
627
628 cat >>"$test_results_path" <<-EOF
629 total $test_count
630 success $test_success
631 fixed $test_fixed
632 broken $test_broken
633 failed $test_failure
634
635 EOF
636 fi
637
638 if test "$test_fixed" != 0
639 then
640 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
641 fi
642 if test "$test_broken" != 0
643 then
644 say_color warn "# still have $test_broken known breakage(s)"
645 fi
646 if test "$test_broken" != 0 || test "$test_fixed" != 0
647 then
648 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
649 msg="remaining $test_remaining test(s)"
650 else
651 test_remaining=$test_count
652 msg="$test_count test(s)"
653 fi
654 case "$test_failure" in
655 0)
656 # Maybe print SKIP message
657 if test -n "$skip_all" && test $test_count -gt 0
658 then
659 error "Can't use skip_all after running some tests"
660 fi
661 test -z "$skip_all" || skip_all=" # SKIP $skip_all"
662
663 if test $test_external_has_tap -eq 0
664 then
665 if test $test_remaining -gt 0
666 then
667 say_color pass "# passed all $msg"
668 fi
669 say "1..$test_count$skip_all"
670 fi
671
672 test -d "$remove_trash" &&
673 cd "$(dirname "$remove_trash")" &&
674 rm -rf "$(basename "$remove_trash")"
675
676 test_at_end_hook_
677
678 exit 0 ;;
679
680 *)
681 if test $test_external_has_tap -eq 0
682 then
683 say_color error "# failed $test_failure among $msg"
684 say "1..$test_count"
685 fi
686
687 exit 1 ;;
688
689 esac
690}
691
692if test -n "$valgrind"
693then
694 make_symlink () {
695 test -h "$2" &&
696 test "$1" = "$(readlink "$2")" || {
697 # be super paranoid
698 if mkdir "$2".lock
699 then
700 rm -f "$2" &&
701 ln -s "$1" "$2" &&
702 rm -r "$2".lock
703 else
704 while test -d "$2".lock
705 do
706 say "Waiting for lock on $2."
707 sleep 1
708 done
709 fi
710 }
711 }
712
713 make_valgrind_symlink () {
714 # handle only executables, unless they are shell libraries that
715 # need to be in the exec-path.
716 test -x "$1" ||
717 test "# " = "$(head -c 2 <"$1")" ||
718 return;
719
720 base=$(basename "$1")
721 symlink_target=$GIT_BUILD_DIR/$base
722 # do not override scripts
723 if test -x "$symlink_target" &&
724 test ! -d "$symlink_target" &&
725 test "#!" != "$(head -c 2 < "$symlink_target")"
726 then
727 symlink_target=../valgrind.sh
728 fi
729 case "$base" in
730 *.sh|*.perl)
731 symlink_target=../unprocessed-script
732 esac
733 # create the link, or replace it if it is out of date
734 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
735 }
736
737 # override all git executables in TEST_DIRECTORY/..
738 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
739 mkdir -p "$GIT_VALGRIND"/bin
740 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
741 do
742 make_valgrind_symlink $file
743 done
744 # special-case the mergetools loadables
745 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
746 OLDIFS=$IFS
747 IFS=:
748 for path in $PATH
749 do
750 ls "$path"/git-* 2> /dev/null |
751 while read file
752 do
753 make_valgrind_symlink "$file"
754 done
755 done
756 IFS=$OLDIFS
757 PATH=$GIT_VALGRIND/bin:$PATH
758 GIT_EXEC_PATH=$GIT_VALGRIND/bin
759 export GIT_VALGRIND
760 GIT_VALGRIND_MODE="$valgrind"
761 export GIT_VALGRIND_MODE
762 GIT_VALGRIND_ENABLED=t
763 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
764 export GIT_VALGRIND_ENABLED
765elif test -n "$GIT_TEST_INSTALLED"
766then
767 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
768 error "Cannot run git from $GIT_TEST_INSTALLED."
769 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
770 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
771else # normal case, use ../bin-wrappers only unless $with_dashes:
772 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
773 if ! test -x "$git_bin_dir/git"
774 then
775 if test -z "$with_dashes"
776 then
777 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
778 fi
779 with_dashes=t
780 fi
781 PATH="$git_bin_dir:$PATH"
782 GIT_EXEC_PATH=$GIT_BUILD_DIR
783 if test -n "$with_dashes"
784 then
785 PATH="$GIT_BUILD_DIR:$PATH"
786 fi
787fi
788GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
789GIT_CONFIG_NOSYSTEM=1
790GIT_ATTR_NOSYSTEM=1
791export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
792
793if test -z "$GIT_TEST_CMP"
794then
795 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
796 then
797 GIT_TEST_CMP="$DIFF -c"
798 else
799 GIT_TEST_CMP="$DIFF -u"
800 fi
801fi
802
803GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
804export GITPERLLIB
805test -d "$GIT_BUILD_DIR"/templates/blt || {
806 error "You haven't built things yet, have you?"
807}
808
809if ! test -x "$GIT_BUILD_DIR"/test-chmtime
810then
811 echo >&2 'You need to build test-chmtime:'
812 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
813 exit 1
814fi
815
816# Test repository
817TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
818test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
819case "$TRASH_DIRECTORY" in
820/*) ;; # absolute path is good
821 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
822esac
823test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
824rm -fr "$TRASH_DIRECTORY" || {
825 GIT_EXIT_OK=t
826 echo >&5 "FATAL: Cannot prepare test area"
827 exit 1
828}
829
830HOME="$TRASH_DIRECTORY"
831GNUPGHOME="$HOME/gnupg-home-not-used"
832export HOME GNUPGHOME
833
834# run the tput tests *after* changing HOME (in case ncurses needs
835# ~/.terminfo for $TERM)
836test -n "${color+set}" || test "x$ORIGINAL_TERM" != "xdumb" && (
837 TERM=$ORIGINAL_TERM &&
838 export TERM &&
839 test -t 1 &&
840 tput bold >/dev/null 2>&1 &&
841 tput setaf 1 >/dev/null 2>&1 &&
842 tput sgr0 >/dev/null 2>&1
843 ) &&
844 color=t
845
846if test -n "$color"
847then
848 say_color () {
849 (
850 TERM=$ORIGINAL_TERM
851 export TERM
852 case "$1" in
853 error)
854 tput bold; tput setaf 1;; # bold red
855 skip)
856 tput setaf 4;; # blue
857 warn)
858 tput setaf 3;; # brown/yellow
859 pass)
860 tput setaf 2;; # green
861 info)
862 tput setaf 6;; # cyan
863 *)
864 test -n "$quiet" && return;;
865 esac
866 shift
867 printf "%s" "$*"
868 tput sgr0
869 echo
870 )
871 }
872else
873 say_color() {
874 test -z "$1" && test -n "$quiet" && return
875 shift
876 printf "%s\n" "$*"
877 }
878fi
879
880if test -z "$TEST_NO_CREATE_REPO"
881then
882 test_create_repo "$TRASH_DIRECTORY"
883else
884 mkdir -p "$TRASH_DIRECTORY"
885fi
886# Use -P to resolve symlinks in our working directory so that the cwd
887# in subprocesses like git equals our $PWD (for pathname comparisons).
888cd -P "$TRASH_DIRECTORY" || exit 1
889
890this_test=${0##*/}
891this_test=${this_test%%-*}
892if match_pattern_list "$this_test" $GIT_SKIP_TESTS
893then
894 say_color info >&3 "skipping test $this_test altogether"
895 skip_all="skip all tests in $this_test"
896 test_done
897fi
898
899# Provide an implementation of the 'yes' utility
900yes () {
901 if test $# = 0
902 then
903 y=y
904 else
905 y="$*"
906 fi
907
908 while echo "$y"
909 do
910 :
911 done
912}
913
914# Fix some commands on Windows
915case $(uname -s) in
916*MINGW*)
917 # Windows has its own (incompatible) sort and find
918 sort () {
919 /usr/bin/sort "$@"
920 }
921 find () {
922 /usr/bin/find "$@"
923 }
924 sum () {
925 md5sum "$@"
926 }
927 # git sees Windows-style pwd
928 pwd () {
929 builtin pwd -W
930 }
931 # no POSIX permissions
932 # backslashes in pathspec are converted to '/'
933 # exec does not inherit the PID
934 test_set_prereq MINGW
935 test_set_prereq NATIVE_CRLF
936 test_set_prereq SED_STRIPS_CR
937 test_set_prereq GREP_STRIPS_CR
938 GIT_TEST_CMP=mingw_test_cmp
939 ;;
940*CYGWIN*)
941 test_set_prereq POSIXPERM
942 test_set_prereq EXECKEEPSPID
943 test_set_prereq CYGWIN
944 test_set_prereq SED_STRIPS_CR
945 test_set_prereq GREP_STRIPS_CR
946 ;;
947*)
948 test_set_prereq POSIXPERM
949 test_set_prereq BSLASHPSPEC
950 test_set_prereq EXECKEEPSPID
951 ;;
952esac
953
954( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
955test -z "$NO_PERL" && test_set_prereq PERL
956test -z "$NO_PYTHON" && test_set_prereq PYTHON
957test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
958test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
959
960# Can we rely on git's output in the C locale?
961if test -n "$GETTEXT_POISON"
962then
963 GIT_GETTEXT_POISON=YesPlease
964 export GIT_GETTEXT_POISON
965 test_set_prereq GETTEXT_POISON
966else
967 test_set_prereq C_LOCALE_OUTPUT
968fi
969
970# Use this instead of test_cmp to compare files that contain expected and
971# actual output from git commands that can be translated. When running
972# under GETTEXT_POISON this pretends that the command produced expected
973# results.
974test_i18ncmp () {
975 test -n "$GETTEXT_POISON" || test_cmp "$@"
976}
977
978# Use this instead of "grep expected-string actual" to see if the
979# output from a git command that can be translated either contains an
980# expected string, or does not contain an unwanted one. When running
981# under GETTEXT_POISON this pretends that the command produced expected
982# results.
983test_i18ngrep () {
984 if test -n "$GETTEXT_POISON"
985 then
986 : # pretend success
987 elif test "x!" = "x$1"
988 then
989 shift
990 ! grep "$@"
991 else
992 grep "$@"
993 fi
994}
995
996test_lazy_prereq PIPE '
997 # test whether the filesystem supports FIFOs
998 case $(uname -s) in
999 CYGWIN*)
1000 false
1001 ;;
1002 *)
1003 rm -f testfifo && mkfifo testfifo
1004 ;;
1005 esac
1006'
1007
1008test_lazy_prereq SYMLINKS '
1009 # test whether the filesystem supports symbolic links
1010 ln -s x y && test -h y
1011'
1012
1013test_lazy_prereq FILEMODE '
1014 test "$(git config --bool core.filemode)" = true
1015'
1016
1017test_lazy_prereq CASE_INSENSITIVE_FS '
1018 echo good >CamelCase &&
1019 echo bad >camelcase &&
1020 test "$(cat CamelCase)" != good
1021'
1022
1023test_lazy_prereq UTF8_NFD_TO_NFC '
1024 # check whether FS converts nfd unicode to nfc
1025 auml=$(printf "\303\244")
1026 aumlcdiar=$(printf "\141\314\210")
1027 >"$auml" &&
1028 case "$(echo *)" in
1029 "$aumlcdiar")
1030 true ;;
1031 *)
1032 false ;;
1033 esac
1034'
1035
1036test_lazy_prereq AUTOIDENT '
1037 sane_unset GIT_AUTHOR_NAME &&
1038 sane_unset GIT_AUTHOR_EMAIL &&
1039 git var GIT_AUTHOR_IDENT
1040'
1041
1042test_lazy_prereq EXPENSIVE '
1043 test -n "$GIT_TEST_LONG"
1044'
1045
1046test_lazy_prereq USR_BIN_TIME '
1047 test -x /usr/bin/time
1048'
1049
1050test_lazy_prereq NOT_ROOT '
1051 uid=$(id -u) &&
1052 test "$uid" != 0
1053'
1054
1055# On a filesystem that lacks SANITY, a file can be deleted even if
1056# the containing directory doesn't have write permissions, or a file
1057# can be accessed even if the containing directory doesn't have read
1058# or execute permissions, causing our tests that validate that Git
1059# works sensibly in such situations.
1060test_lazy_prereq SANITY '
1061 mkdir SANETESTD.1 SANETESTD.2 &&
1062
1063 chmod +w SANETESTD.1 SANETESTD.2 &&
1064 >SANETESTD.1/x 2>SANETESTD.2/x &&
1065 chmod -w SANETESTD.1 &&
1066 chmod -rx SANETESTD.2 ||
1067 error "bug in test sript: cannot prepare SANETESTD"
1068
1069 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1070 status=$?
1071
1072 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1073 rm -rf SANETESTD.1 SANETESTD.2 ||
1074 error "bug in test sript: cannot clean SANETESTD"
1075 return $status
1076'
1077
1078GIT_UNZIP=${GIT_UNZIP:-unzip}
1079test_lazy_prereq UNZIP '
1080 "$GIT_UNZIP" -v
1081 test $? -ne 127
1082'